#ifndef CREATEMODEL_H
#define CREATEMODEL_H 1
#include "base/Operator.h"
#include "base/DataInCoreFloat.h"
#include "base/inCoreFloat.h"
#include "base/Vector.h"
#include <cmath>
#include <omp.h>
#include <iostream>
typedef long long llong;
/*
Model creation module
Used to simplify the main code.

Created:       2015-07-06
Last modified: 2015-07-06

*/

namespace SEP {

class Models{
  
  public:
    Models(llong _nz, llong _nx, float _velocity, float _density){
      nz = _nz;
      nx = _nx;
      velocity = _velocity;
      density  = _density;
    }
    ~Models(){}
    void Model0(Vector *Vel, Vector *rho);
    void Model1(Vector *Vel, Vector *rho);
  private:
    llong nz,nx;
    float velocity, density;
};

void Models::Model0(Vector *Vel, Vector *rho) {
  float *__restrict__ v_val = ((dataInCoreFloat*)Vel->getDataContainer())->getFloatPtr();   
  float *__restrict__ rho_val = ((dataInCoreFloat*)rho->getDataContainer())->getFloatPtr();  

  for(llong i1=0; i1<200;i1++){
    for(llong i2=0; i2<nx; i2++){
      llong i = i1*nx+i2;
      v_val[i] = velocity;
      rho_val[i] = density*1.0;//*(2.+(i1-200.)/200.);
      //rho_val[i] = density*1.0*(2.+(i1-200.)/200.);
    }
  }   

  for(llong i1=200; i1<nz;i1++){
    for(llong i2=0; i2<nx; i2++){
      llong i = i1*nx+i2;
      v_val[i] = velocity*1.1;//*1.1;
      rho_val[i] = density*1.1;//*1.1;//*(2.+(i1-200.)/200.);
    }
  }     
  for(llong i1=310; i1<nz;i1++){
    for(llong i2=0; i2<nx; i2++){
      llong i = i1*nx+i2;
      v_val[i] = velocity*1.1;//*1.1;
      rho_val[i] = density*1.4;//*1.1;//*(2.+(i1-200.)/200.);
    }
  } 
}

void Models::Model1(Vector *Vel, Vector *rho) {
  float *__restrict__ v_val = ((dataInCoreFloat*)Vel->getDataContainer())->getFloatPtr();   
  float *__restrict__ rho_val = ((dataInCoreFloat*)rho->getDataContainer())->getFloatPtr();  

  for(llong i1=0; i1<200;i1++){
    for(llong i2=0; i2<nx; i2++){
      llong i = i1*nx+i2;
      v_val[i] = velocity;
      rho_val[i] = density*1.0;//*(2.+(i1-200.)/200.);
    }
  }   
 
  for(llong i1=200; i1<nz;i1++){
    for(llong i2=0; i2<nx; i2++){
      llong i = i1*nx+i2;
      v_val[i] = velocity*1.1;//*1.1;
      rho_val[i] = density*1.1;//*1.3;//*1.1;//*(2.+(i1-200.)/200.);
    }
  } 
  for(llong i1=310; i1<nz;i1++){
    for(llong i2=0; i2<nx; i2++){
      llong i = i1*nx+i2;
      v_val[i] = velocity*1.1;//*1.1;
      rho_val[i] = density*1.4;//*1.1;//*(2.+(i1-200.)/200.);
    }
  } 

  //v_val[150*nx+250] = velocity*1.1;
  //rho_val[150*nx+250] = density*1.1;
  int cx = 438, cz=140;
  for(llong i1=0; i1<nz;i1++){
    for(llong i2=0; i2<nx; i2++){
      llong i = i1*nx+i2;
      float distance = (i2-cx)*(i2-cx)+(i1-cz)*(i1-cz);
      //  if(distance < 800.){
        rho_val[i] = rho_val[i]+0.012*density*exp(-1.*distance/300.);
        v_val[i] = v_val[i]+0.01*velocity*exp(-1.*distance/300.);
    //  }
    }
  }
  /*
   for(llong i1=0; i1<nz;i1++){
    for(llong i2=0; i2<nx; i2++){
      llong i = i1*nx+i2;
      float distance = (i2-310.)*(i2-310.)+(i1-120.)*(i1-120.);
     // if(distance < 800.){
        rho_val[i] = rho_val[i]+0.1*density*exp(-1.*distance/300.);
        //v_val[i] = v_val[i]-0.1*velocity*exp(-1.*distance/100.);
   //   }
    }
  } 
  */
}


}

#endif