#ifndef INTERPOLATION_H
#define INTERPOLATION_H 1

#include "base/Operator.h"
#include "base/DataInCoreFloat.h"
#include "base/inCoreFloat.h"
#include "Clean.h"
#include <omp.h>
typedef long long llong;

/*
    Interpolation Operator
    
    Use to interpolate from regular grid to staggered grid
    Use carefully and have fun.
    
    First Created: 2015-11-03
    Last Modified: 2015-11-03

*/


namespace SEP{

class IntX: public Operator{
  public:
  	IntX(Space *mod, Space *data);
  	~IntX(){}
  	virtual bool Forward(bool add, Vector *model, Vector *data);
  	virtual bool Adjoint(bool add, Vector *model, Vector *data);
  	
  private:
    void init();
    llong nz, nx;
    CleanVec Zero;
};

class IntZ: public Operator{
  public:
  	IntZ(Space *mod, Space *data);
  	~IntZ(){}
  	virtual bool Forward(bool add, Vector *model, Vector *data);
  	virtual bool Adjoint(bool add, Vector *model, Vector *data);
  	
  private:
    void init();
    llong nz, nx;
    CleanVec Zero;
};





} // end of namespace
#endif