#ifndef LAPLACIAN_H
#define LAPLACIAN_H 1

#include "base/Operator.h"
#include "base/DataInCoreFloat.h"
#include "base/inCoreFloat.h"
#include "Clean.h"
#include <omp.h>
typedef long long llong;

/*
  Created by Yinbin Ma
  8th order Laplacian in 2d.
  (n3,n2,n1) notation, n1 is the fast axis.
  Use carefully and have fun.
  
  First Created: 2015-10-30
  Last Modified: 2015-10-30
  
#define zxloc(iz,ix) ((iz)+(ix)*XC2dRTM_nz)

*/
extern "C" void LapISPCForward(float *pin,float *pout, int n1, int n2);
extern "C" void LapISPCAdjoint(float *pin,float *pout, int n1, int n2);

namespace SEP {

class Laplacian4: public Operator{
  public:
    Laplacian4(Space *mod, Space *data);
    ~Laplacian4(){}
    virtual bool Forward(bool add, Vector *model, Vector *data);
    virtual bool Adjoint(bool add, Vector *model, Vector *data);
    
  private:
    llong n1, n2, i1, i2, position, order;
    double coef[10];
    CleanVec Zero;
    void init();

};



}
#endif