#ifndef SENSORPAD_H
#define SENSORPAD_H 1
#include "base/Operator.h"
#include "base/DataInCoreFloat.h"
#include "base/inCoreFloat.h"
#include "Clean.h"
typedef long long llong;

/*
Sensor padding operator

  Use to inject data[nt][nx] to source[nt][nz][nx]
  With fixed depth sz
  Need to set shot location sx each time, before calling this function.
  Use carefully and have fun.
  
  First Created: 2015-11-02
  Last Modified: 2015-11-02 

*/

namespace SEP {

class SensorPad: public Operator{

  public:
    SensorPad(Space *mod, Space *data, llong sz, llong bnx=0);
    void SetShot(llong _sx){ sx = _sx;}
    virtual bool Forward(bool add, Vector *model, Vector *data);
    virtual bool Adjoint(bool add, Vector *model, Vector *data);

  private:
    void init(llong sz, llong bnx);
    llong nt, nz, nx;
    llong sz, bnx, sx, nm;
    CleanVec Zero;
};

} // end of namespace

#endif
