#ifndef TAPER_H
#define TAPER_H 1
#include "base/Operator.h"
#include "base/DataInCoreFloat.h"
#include "base/inCoreFloat.h"
#include "base/Vector.h"
#include <cmath>
#include <omp.h>
#include <iostream>
typedef long long llong;
/*
Wave propagation module
Need to set velocity and taper before running
Assume source field ready to use.

 Notice: nx, nz are labeled in the opposite way.
 I am too lazy to change all the variables.
 It works. Use carefully
Created:       2015-01-15
Last modified: 2015-01-27

*/
extern "C" void TaperISPC(float *cur,float *next,float *tap, int bnx, int n1, int n2);

namespace SEP {

class Taper{
  
  public:
    Taper(Vector *vec, llong _bnz, llong _bnx, float _alpha);
    ~Taper(){}
    void tape(Vector *model);
    void tapeISPC(Vector *cur, Vector *next);
  private:
    void init(Vector *vec, llong _bnz, llong _bnx, float _alpha);
    llong nz,nx,nt, bnz,bnx;
    //float alpha,pi;
    float alpha;
    Vector *taper;   
    inCoreFloat *mspace;


};





}

#endif