#include <iostream>
#include <cstdlib>
#include <stdbool.h>
#include <vector>
#include <cmath>
#include<string>
#include "seplib.h"

#include <omp.h>
#include "Laplacian.h"
#include "Source.h"
#include "SensorPad.h"
#include "Grad.h"
#include "Interpolation.h"
#include "Born.h"
#include "Prop.h"
#include "Engine.h"
#include "CreateModel.h"
#include "HessInv.h"
#include "Wrapper.h"
#include "NCG.h"
#include "utilities.h"
#include "mkl_rci.h"
#include "mkl_blas.h"
#include "mkl_spblas.h"
#include "mkl_service.h"
extern "C" {
#include "sep3d.h"
}
using namespace std;
using namespace SEP;



/*
Beta version for Multiparameter FWI

Generated by Yinbin: 2015-07-06

Assume: 
	1) source term
	2) initial condition with gradient = 0
	3) K[GPa], t[ms], rho[g/cm^3]
*/

int main(int argc, char *argv[]) {
  cout << "========================================"<<endl;
  cout << "                                        "<<endl;
  cout << "========================================"<<endl;
  cout << "              Test Modulus.        "<<endl;
  initpar(argc,argv);       // Initialize the sep library
  omp_set_num_threads(1);   // Initialize the parallel environment
  
  // Define dimension of interest
  int nx=571;
  int nx0=461;
  int bnx=55;
  int nz=261;
  int nz0=151;
  int bnz=55;
  int niter=101;
  
  float *T  = new float[nx*nz];
  float *NC = new float[nx*nz*niter];
  float *M  = new float[nx*nz];

  sreed("ModT",T,sizeof(float)*nz*nx);
  sreed("ModM",M,sizeof(float)*nz*nx);
  sreed("ModO",NC,sizeof(float)*nz*nx*niter);  
  
  float *tot = new float[3*nx0*nz0*niter];
  int mb0 = nz0*nx0;
  int mb = nz*nx;
  for(int iter=0;iter<niter;iter++){
    for(int iz=0;iz<nz0;iz++){
      int shifttot=iter*mb0*3+iz*nx0*3;
      int shiftS = (iz+bnz)*nx + bnx;
      int shiftO = iter*mb+(iz+bnz)*nx + bnx;
      memcpy(&tot[shifttot],&M[shiftS],sizeof(float)*nx0);
      memcpy(&tot[shifttot+nx0],&NC[shiftO],sizeof(float)*nx0);
      memcpy(&tot[shifttot+2*nx0],&T[shiftS],sizeof(float)*nx0);
    }
  }

 srite("ModA",tot,sizeof(float)*3*nx0*nz0*niter);
 return 0;

}
