#include <iostream>
#include <cstdlib>
#include <stdbool.h>
#include <vector>
#include <cmath>
#include<string>
#include "seplib.h"

#include "base/Operator.h"
#include "base/DataInCoreFloat.h"
#include "base/inCoreFloat.h"
using namespace std;
using namespace SEP;




int main(int argc, char *argv[]) {
  cout << "========================================"<<endl;
  cout << "                                        "<<endl;
  cout << "========================================"<<endl;
  cout << "              Test Modulus.        "<<endl;
  initpar(argc,argv);       // Initialize the sep library

  int nx=461, nz=151;
  int nxb=571, nzb=261;
  float *InT = new float[nx*nz];
  float *OutT = new float[nxb*nzb];
  int depth;
  float factor, value;
  getch("depth","d",&depth); 
  getch("factor","f",&factor);
  getch("value","f",&value);
  sreed("InModel",InT,sizeof(float)*nx*nz); 
  


  for(int ix=0;ix<nxb;ix++){
    for(int iz=0; iz < nzb; iz++){
      int positionOut = ix*nzb+iz;
      int inx = min(max(0,ix-55),nx-1);
      int inz = min(max(0,iz-55),nz-1);
      int positionIn  = inx*nz + inz;
      OutT[positionOut] = InT[positionIn]/factor; 
    }
  }

  for(int ix=0; ix < nxb;ix++){
    for(int iz=0;iz<55+depth;iz++){
       int positionOut = ix*nzb+iz; 
       OutT[positionOut] = value;   
    }
  }  
  
  srite("OutModel",OutT,sizeof(float)*nxb*nzb); 
 
  return 0;
}
