#include <iostream>
#include <cstdlib>
#include <stdbool.h>
#include <vector>
#include <cmath>
#include<string>
#include "seplib.h"

#include "base/Operator.h"
#include "base/DataInCoreFloat.h"
#include "base/inCoreFloat.h"
using namespace std;
using namespace SEP;




int main(int argc, char *argv[]) {
  cout << "========================================"<<endl;
  cout << "                                        "<<endl;
  cout << "========================================"<<endl;
  cout << "              Test Modulus.        "<<endl;
  initpar(argc,argv);       // Initialize the sep library

  int nx=571, nz=261;
  float *InT = new float[nx*nz];
  float *OutT = new float[nx*nz];
  float *InR = new float[nx*nz];
  float *OutR = new float[nx*nz];
  float *topb = new float[nx];
  sreed("InModelV",InT,sizeof(float)*nx*nz); 
  sreed("InModelR",InR,sizeof(float)*nx*nz);
  float dv = 0.2;
  float dr = 0.23;
  int up=100;
  int down=130;
  int left=350;
  int right=400;
  //up=0;down=161;left=320;right=571;
  for(int ix=left;ix<right;ix++){
    for(int iz=up; iz < down; iz++){
      int position = ix*nz+iz;
      if(InT[position] > 3.2){
       OutT[position] = dv*1.5;
       OutR[position] = dr*1.5; 
       }
    }
  }

  up=130;down=150;left=140;right=210;  

  for(int ix=left;ix<right;ix++){
    for(int iz=up; iz < down; iz++){
      int position = ix*nz+iz;
      if(InT[position] > 3.2){
        OutT[position] = -dv; 
        OutR[position] = -dr; 
      }
    }
  }
  for(int ix=left;ix<right;ix++){
    for(int iz=up; iz < down; iz++){
      int position = ix*nz+iz;
      if(OutT[position] < -0.03){
        topb[ix] = iz;
        break;
      }
    }
  }  

  for(int ix=left;ix<right;ix++){
    for(int iz=up; iz < down; iz++){
      int position = ix*nz+iz;
      float dist=0.;
      if(ix < 150) dist=150.-ix;
      if(ix > 200) dist=ix-200.;

      float damp = exp(-dist*dist/40.);
      OutT[position] =OutT[position]*damp; 
      OutR[position] =OutR[position]*damp; 
    }
  }
  
  int centerx=175;
  int centerz=144;
  for(int ix=left;ix<right;ix++){
    for(int iz=0;iz<150;iz++){
      int position = ix*nz+iz;
      float dist = (ix-centerx)*(ix-centerx)+(iz-centerz)*(iz-centerz);
      if(iz<topb[ix]){
        OutT[position] = -dv*exp(-dist/600.);
       // OutR[position] = -dr*exp(-dist/600.);
      }
    }
  }



  
  srite("OutModelV",OutT,sizeof(float)*nx*nz); 
  srite("OutModelR",OutR,sizeof(float)*nx*nz); 
  return 0;
}
