#ifndef ADMMALG_H
#define ADMMALG_H 1
#include "Algorithm.h"
#include "CGAlg.h"
#include "Operator.h"
#include "MultiOperator.h"
#include "DataInCoreFloat.h"
#include "inCoreFloat.h"


#include <iostream>
namespace SEP {

class Shrink: public Algorithm {

  public:
    Shrink(Vector & _z, double _threshold):z(_z) {
    init(_threshold);

    }
    void run();
    long long zeros;
  private:
    Vector &z;
    double threshold;
    long long n123;
    float *__restrict__ d;
    void init(double _threshold);



};


class ADMM_Solver: public Algorithm{

  public:

    ADMM_Solver(Operator & _L, Operator & _A,
        Vector & _m,
        Vector & _d,
        double _lambda,
        double _rho,
        int    &_niter)
      :L(_L),A(_A),m(_m),d(_d),niter(_niter)
      { 
        // initilizer, could be complicated
        init(_lambda,_rho);
      }

    void SetPar(int _maxiter,double _rtol, double _nrtol);
    void SetSPPar(int _maxInner, int _maxCG);
    bool stop();
    void run();

    ~ADMM_Solver(){ delete u; delete z;}


  private:
    Operator       & L;
    Operator       & A;    // Operator
    Vector         & m;    // solution vector
    Vector         & d;
    int            &niter;
    Vector         *u,*z;

    inCoreFloat    *mspace, *dspace,*zspace,*bspace;


    double         lambda;
    double          rho;
    double          rhos;
    double         rtol;   // tolerance of residual norm
    double         nrtol;  // tolerance of gradient norm
    double         rnorm, nrnorm;
    int            maxiter, maxCG, maxInner;
    bool           verbose;
    void init(double lambda,double rho);


};

}

#endif