// Algorithm.H
// Created by YM
/*
Get the idea from RVL.
Please check the following link for reference
http://www.trip.caam.rice.edu/software/rvl/alg/doc/html/alg_8hh_source.html



*/

#ifndef ALGORITHM_H
#define ALGORITHM_H 1
#include "Space.h"
#include "Vector.h"
#include <iostream>


namespace SEP {
/// 
///
class Algorithm {
  public:
  Algorithm() {}
  ~Algorithm() {}

  virtual void run() = 0;

};

class NoAlg: public Algorithm {
  public:
    void run() {};
};

class Terminator {
  public:
    virtual ~Terminator() {}
    virtual bool query() = 0;

};



class LoopAlg: public Algorithm {
  public:
    LoopAlg(Algorithm & alg, Terminator & stop): inside(alg), term(stop) {}

    virtual void run() {
      while((!term.query())) {
        inside.run();
      }
    }
  protected:
    Algorithm & inside;
    Terminator & term;
};

}

#endif