#include "CGStep.h"
#include "math.h"
#include <iostream>
#include "Vector.h"
#include "inCoreFloat.h"
#include "DataInCoreFloat.h"

void SEP::CGStep::Alloc_step(Vector *mod, Vector *data){
//     std::cout << "in alloc";
      fprintf(stderr,"In alloc \n");
    		//Vector v2 = v1.clone();
  *s=mod->clone();fprintf(stderr,"In alloc \n");
  //s=mod.clone();fprintf(stderr,"In alloc \n");
  *ss=data->clone();
}

bool SEP::CGStep::Step(int iter, Vector *m, Vector *g, Vector *rr, Vector *gg, double *res){

  double alpha,beta=0,small=1e-20;
     std::cout << "in cgstep";
  double gg_gg=gg->innerProd(gg);
  double gg_rr=-gg->innerProd(rr);


  if(iter==0){
    alpha = -gg_rr/gg_gg;
    if(fabs(gg_gg) < small){
      fprintf(stderr,"Zero dot product in first CG step \n");
      return false;
    }
  }
  else{

    double ss_ss=ss->innerProd(ss);
    double gg_ss=gg->innerProd(ss);
    if(fabs(gg_gg) < small || fabs(ss_ss) < small){
      fprintf(stderr,"Zero dot product in CG step \n");
      return false;
    }

    double determ=gg_gg*ss_ss*( (1.-gg_ss/gg_gg)*(gg_ss/ss_ss) );
    double ss_rr=-ss->innerProd(rr);
    alpha = (ss_ss*gg_rr - gg_ss*ss_rr)/determ;
    beta = (-gg_ss*gg_rr + gg_gg*ss_rr)/determ;
  }

  s->linearCombo(beta,g,alpha);   //Update solution step alpha*g+beta*s
  ss->linearCombo(beta,gg,alpha); //Update residual step

  m->linearCombo(1.0,s,1.0);      //Update solution
  rr->linearCombo(1.0,ss,1.0);    //Update residual

  *res=rr->innerProd(rr);

  fprintf(stderr,"Residual is %g \n",*res);

  return true;

}
