#inclode<ComboOper.h>

ColOp::ColOp(Operator *op1, Operator *op2){
  oper1=op1;
  oper2=op2;
  createSuperSpace();
}
void ColOp::CreateSuperSpace(){
   if(oper1->getDomain()!=oper2->getDomain()) {
        SEPException e;
        e<<"The domains must be the same when creating a ColOp";
        throw e;
      }
    setDomain(oper1->getDomain());
    MultiSpace ComboSpace=MultiSpace(oper1->getRange(),oper2->getRange());
    setRange(&ComboSpace);
    
}

bool ColOp::Forward(bool add, Vector *model, Vector *data ){
  checkLogic(model,data);
  //I really don't like the way I am doing this
  MultiDataContainer *x=(MultiDataContainer*) data->getDataContainer();
  Vector fake1=Vector(ComboSpace->getSpace1(), x->getData1());
  Vector fake2=Vector(ComboSpace->getSpace2(), x->getData2());

  oper1->Forward(add,model,&fake1);
  oper2->Forward(add,model,&fake2);
}
bool ColOp::ForwardAdd(bool add, Vector *model, Vector *data, float b){
  checkLogic(model,data);
  //I really don't like the way I am doing this
   MultiDataContainer *x=(MultiDataContainer*) data->getDataContainer();
  Vector fake1=Vector(ComboSpace->getSpace1(), x->getData1());
  Vector fake2=Vector(ComboSpace->getSpace2(), x->getData2());

  oper1->ForwardAdd(add,model,&fake1,b);
  oper2->ForwardAdd(add,model,&fake2,b);
 
}
bool ColOp::ForwardScaleAdd(bool add, Vector *model, Vector *data, Vector *scale, float b){

  checkLogic(model,data);
  //I really don't like the way I am doing this
   MultiDataContainer *x=(MultiDataContainer*) data->getDataContainer();
  MultiDataContainer *x=(MultiDataContainer*) scale->getDataContainer();
  Vector fake1=Vector(ComboSpace->getSpace1(), x->getData1());
  Vector fake2=Vector(ComboSpace->getSpace2(), x->getData2());
  Vector scale1=Vector(ComboSpace->getSpace1(),y->getData1());
  Vector scale2=Vector(ComboSpace->getSpace2(),y->getData2());

  oper1->ForwardScaleAdd(add,model,&fake1,&scale1,b);
  oper2->ForwarScaledAdd(add,model,&fake2,&scale2, b);
 

}
bool ColOp::Adjoint(bool add, Vector *model, Vector *data ){

  checkLogic(model,data);
  //I really don't like the way I am doing this
  MultiDataContainer *x=(MultiDataContainer*) data->getDataContainer();
  Vector fake1=Vector(ComboSpace->getSpace1(), x->getData1());
  Vector fake2=Vector(ComboSpace->getSpace2(), x->getData2());

  oper1->Adjoint(add,model,&fake1);
  oper2->Adjoint(true,model,&fake2);

}
bool ColOp::AdjointAdd(bool add, Vector *model, Vector *data, float b){
  checkLogic(model,data);
  //I really don't like the way I am doing this
   MultiDataContainer *x=(MultiDataContainer*) data->getDataContainer();
  Vector fake1=Vector(ComboSpace->getSpace1(), x->getData1());
  Vector fake2=Vector(ComboSpace->getSpace2(), x->getData2());

  oper1->AdjointAdd(add,model,&fake1,b);
  oper2->AdjointAdd(true,model,&fake2,b);

}
bool ColOp::AdjointScaleAdd(bool add, Vector *model, Vector *data, Vector *scale, float b){

  checkLogic(model,data);
  //I really don't like the way I am doing this
   MultiDataContainer *x=(MultiDataContainer*) data->getDataContainer();
  MultiDataContainer *x=(MultiDataContainer*) scale->getDataContainer();
  Vector fake1=Vector(ComboSpace->getSpace1(), x->getData1());
  Vector fake2=Vector(ComboSpace->getSpace2(), x->getData2());
  Vector scale1=Vector(ComboSpace->getSpace1(),y->getData1());
  Vector scale2=Vector(ComboSpace->getSpace2(),y->getData2());

  oper1->AdjointScaleAdd(add,model,&fake1,&scale1,b);
  oper2->AdjointScaledAdd(true,model,&fake2,&scale2, b);
}


ChainOp::ChainOp(Operator *op1, Operator *op2,bool saveSpace){
  oper1=op1;
  oper2=op2;
  createSuperSpace();
  spaceSave=saveSpace;
}
void ChainOp::CreateSuperSpace(){
   if(oper1->getRange()!=oper2->getDomain()) {
        SEPException e;
        e<<"The domains must be the same when creating a ColOp";
        throw e;
      }
    setDomain(oper1->getDomain());
    setRange(oper2->getRange());
    if(!spaceSave()){
      DataContainer *dat=interSpace->oper1->getRange();
      interVector=Vector(oper1->getRange(),dat);
    }
}

bool ChainOp::Forward(bool add, Vector *model, Vector *data ){
  checkLogic(model,data);
  //I really don't like the way I am doing this
  MultiDataContainer *x=(MultiDataContainer*) data->getDataContainer();
  Vector fake1=Vector(ComboSpace->getSpace1(), x->getData1());
  Vector fake2=Vector(ComboSpace->getSpace2(), x->getData2());
    if(spaceSave()){
      DataContainer *dat=interSpace->oper1->getRange();
      interVector2=Vector(oper1->getRange(),dat);
      oper1->Forward(false,model,&fake1);
      oper2->Forward(add,model,&fake2);
    }

}
bool ChainOp::ForwardAdd(bool add, Vector *model, Vector *data, float b){
  checkLogic(model,data);
  //I really don't like the way I am doing this
   MultiDataContainer *x=(MultiDataContainer*) data->getDataContainer();
  Vector fake1=Vector(ComboSpace->getSpace1(), x->getData1());
  Vector fake2=Vector(ComboSpace->getSpace2(), x->getData2());

  oper1->ForwardAdd(add,model,&fake1,b);
  oper2->ForwardAdd(add,model,&fake2,b);
 
}
bool ChainOp::ForwardScaleAdd(bool add, Vector *model, Vector *data, Vector *scale, float b){

  checkLogic(model,data);
  //I really don't like the way I am doing this
   MultiDataContainer *x=(MultiDataContainer*) data->getDataContainer();
  MultiDataContainer *x=(MultiDataContainer*) scale->getDataContainer();
  Vector fake1=Vector(ComboSpace->getSpace1(), x->getData1());
  Vector fake2=Vector(ComboSpace->getSpace2(), x->getData2());
  Vector scale1=Vector(ComboSpace->getSpace1(),y->getData1());
  Vector scale2=Vector(ComboSpace->getSpace2(),y->getData2());

  oper1->ForwardScaleAdd(add,model,&fake1,&scale1,b);
  oper2->ForwarScaledAdd(add,model,&fake2,&scale2, b);
 

}
bool ChainOp::Adjoint(bool add, Vector *model, Vector *data ){

  checkLogic(model,data);
  //I really don't like the way I am doing this
  MultiDataContainer *x=(MultiDataContainer*) data->getDataContainer();
  Vector fake1=Vector(ComboSpace->getSpace1(), x->getData1());
  Vector fake2=Vector(ComboSpace->getSpace2(), x->getData2());

  oper1->Adjoint(add,model,&fake1);
  oper2->Adjoint(true,model,&fake2);

}
bool ChainOp::AdjointAdd(bool add, Vector *model, Vector *data, float b){
  checkLogic(model,data);
  //I really don't like the way I am doing this
   MultiDataContainer *x=(MultiDataContainer*) data->getDataContainer();
  Vector fake1=Vector(ComboSpace->getSpace1(), x->getData1());
  Vector fake2=Vector(ComboSpace->getSpace2(), x->getData2());

  oper1->AdjointAdd(add,model,&fake1,b);
  oper2->AdjointAdd(true,model,&fake2,b);

}
bool ChainOp::AdjointScaleAdd(bool add, Vector *model, Vector *data, Vector *scale, float b){

  checkLogic(model,data);
  //I really don't like the way I am doing this
   MultiDataContainer *x=(MultiDataContainer*) data->getDataContainer();
  MultiDataContainer *x=(MultiDataContainer*) scale->getDataContainer();
  Vector fake1=Vector(ComboSpace->getSpace1(), x->getData1());
  Vector fake2=Vector(ComboSpace->getSpace2(), x->getData2());
  Vector scale1=Vector(ComboSpace->getSpace1(),y->getData1());
  Vector scale2=Vector(ComboSpace->getSpace2(),y->getData2());

  oper1->AdjointScaleAdd(add,model,&fake1,&scale1,b);
  oper2->AdjointScaledAdd(true,model,&fake2,&scale2, b);
}


DiagOp::DiagOp(Operator *op1, Operator *op2){
  oper1=op1;
  oper2=op2;
  createSuperSpace();
}
void DiagOp::CreateSuperSpace(){
    MultiSpace domainSpace=MultiSpace(oper1->getDomain(),oper2->getDomain());
    setRange(&domainSapce);
        MultiSpace rangeSpace=MultiSpace(oper1->getRange(),oper2->getRange());
    setRange(&rangeSpace);
}

bool DiagOp::Forward(bool add, Vector *model, Vector *data ){
  checkLogic(model,data);
  //I really don't like the way I am doing this
  MultiDataContainer *x=(MultiDataContainer*) model->getDataContainer();
  MultiDataContainer *y=(MultiDataContainer*) data->getDataContainer();

  Vector fakem1=Vector(domainSpace->getSpace1(), x->getData1());
  Vector fakem2=Vector(domainSpace->getSpace2(), x->getData2());
  Vector faked1=Vector(domainRange->getSpace1(), x->getData1());
  Vector faked2=Vector(domainrange->getSpace2(), x->getData2());
  oper1->Forward(add,&fakem1,&faked1);
  oper2->Forward(add,&fakem2,&faked2);
}
bool DiagOp::ForwardAdd(bool add, Vector *model, Vector *data, float b){
 checkLogic(model,data);
  //I really don't like the way I am doing this
  MultiDataContainer *x=(MultiDataContainer*) model->getDataContainer();
  MultiDataContainer *y=(MultiDataContainer*) data->getDataContainer();

  Vector fakem1=Vector(domainSpace->getSpace1(), x->getData1());
  Vector fakem2=Vector(domainSpace->getSpace2(), x->getData2());
  Vector faked1=Vector(domainRange->getSpace1(), x->getData1());
  Vector faked2=Vector(domainrange->getSpace2(), x->getData2());

  oper1->ForwardAdd(add,&fakem1,&faked1,b);
  oper2->ForwardAdd(add,&fakem2,&faked2,b);
 
}
bool DiagOp::ForwardScaleAdd(bool add, Vector *model, Vector *data, Vector *scale, float b){

 checkLogic(model,data);
  //I really don't like the way I am doing this
  MultiDataContainer *x=(MultiDataContainer*) model->getDataContainer();
  MultiDataContainer *y=(MultiDataContainer*) data->getDataContainer();

  Vector fakem1=Vector(domainSpace->getSpace1(), x->getData1());
  Vector fakem2=Vector(domainSpace->getSpace2(), x->getData2());
  Vector faked1=Vector(domainRange->getSpace1(), x->getData1());
  Vector faked2=Vector(domainrange->getSpace2(), x->getData2());
  Vector scale1=Vector(domainSpace->getSpace1(),y->getData1());
  Vector scale2=Vector(domainSpace->getSpace2(),y->getData2());

  oper1->ForwardScaleAdd(add,model,&fakem1,&faked1,b);
  oper2->ForwarScaledAdd(add,model,&fakem2,&faked2, b);
 

}
bool DiagOp::Adjoint(bool add, Vector *model, Vector *data ){

 checkLogic(model,data);
  //I really don't like the way I am doing this
  MultiDataContainer *x=(MultiDataContainer*) model->getDataContainer();
  MultiDataContainer *y=(MultiDataContainer*) data->getDataContainer();

  Vector fakem1=Vector(domainSpace->getSpace1(), x->getData1());
  Vector fakem2=Vector(domainSpace->getSpace2(), x->getData2());
  Vector faked1=Vector(domainRange->getSpace1(), x->getData1());
  Vector faked2=Vector(domainrange->getSpace2(), x->getData2());

  oper1->Adjoint(add,&fakem1,&faked1);
  oper2->Adjoint(add,&fakem2,&faked2);

}
bool DiagOp::AdjointAdd(bool add, Vector *model, Vector *data, float b){
 checkLogic(model,data);
  //I really don't like the way I am doing this
  MultiDataContainer *x=(MultiDataContainer*) model->getDataContainer();
  MultiDataContainer *y=(MultiDataContainer*) data->getDataContainer();

  Vector fakem1=Vector(domainSpace->getSpace1(), x->getData1());
  Vector fakem2=Vector(domainSpace->getSpace2(), x->getData2());
  Vector faked1=Vector(domainRange->getSpace1(), x->getData1());
  Vector faked2=Vector(domainrange->getSpace2(), x->getData2());

  oper1->AdjointAdd(add,&fakem1,&faked1,b);
  oper2->AdjointAdd(add,&fakem2,&faked2,b);

}
bool DiagOp::AdjointScaleAdd(bool add, Vector *model, Vector *data, Vector *scale, float b){

 checkLogic(model,data);
  //I really don't like the way I am doing this
  MultiDataContainer *x=(MultiDataContainer*) model->getDataContainer();
  MultiDataContainer *y=(MultiDataContainer*) data->getDataContainer();

  Vector fakem1=Vector(domainSpace->getSpace1(), x->getData1());
  Vector fakem2=Vector(domainSpace->getSpace2(), x->getData2());
  Vector faked1=Vector(domainRange->getSpace1(), x->getData1());
  Vector faked2=Vector(domainrange->getSpace2(), x->getData2());
  Vector scale1=Vector(ComboSpace->getSpace1(),y->getData1());
  Vector scale2=Vector(ComboSpace->getSpace2(),y->getData2());

  oper1->AdjointScaleAdd(add,&fakem1,&fakend1,&scale1,b);
  oper2->AdjointScaledAdd(add,&fakem2,&faked2,&scale2, b);
}