#include "Operator.h"
#include <math.h>
#include <stdio.h>
#include <iostream>

using namespace std;

  void SEP::Map::setDomain(Space *dom){
    /// Set the domain (i.e. model space) of the map
    ///
    domain=dom;
  }

  void SEP::Map::setRange(Space *ran){
    /// Set the range (i.e. data space) of the map
    ///
    range=ran;
  }

/*
void SEP::Map::checkLogic(Vector *model,Vector *data){


    if(returnDomain()!=model->getSpace()){
              e<<"The domains of operator model vector not the same";
        throw e;
      }
     if(returnRange()!=data->getSpace()){
              e<<"The range of operator model vector not the same";
        throw e;
      }
      
}
*/

bool SEP::Operator::DotTest(bool verb/*, Space *dom, Space *ran*/){
  /// Test that (Fx,y) = x*F*y = (x,Fy) 
  /// (Linear algebra identity)

  Vector m1(domain);//=new Vector(domain);
  Vector d1(range);//=new Vector(range);
  Vector m2(domain);//=new Vector(domain);
  Vector d2(range);//=new Vector(range);

  m1.random();
  d2.random();

  Forward(false,&m1,&d1);
  
  double dot1=d1.innerProd(d2);

  Adjoint(false,&m2,&d2);
  double dot2=m2.innerProd(m1);

  if(verb) std::cout<<"Dot product test with add=false: \n"<<dot1<<"\n"<<dot2<<"\n";

  Forward(true,&m1,&d1);
  double dot3=d1.innerProd(d2);

  Adjoint(true,&m2,&d2);
  double dot4=m2.innerProd(m1);

  if(verb) std::cout<<"Dot product test with add=true: \n"<<dot3<<"\n"<<dot4<<"\n";

  return true;
}


