#ifndef OPERATOR_H
#define OPERATOR_H 1
#include "Space.h"
#include "Vector.h"
#include <iostream>

namespace SEP {

class Map{
  private:

  protected:

  public:
    Map() { }
    //Map(const Map &) {}
    virtual ~Map() { }

    Space *domain,*range; // Should we set them to be private/protected?
    void setDomain(Space *dom);
    void setRange(Space *ran);
    Space* getDomain(){ return domain;}
    Space* getRange(){return range;}
    void checkLogic(Vector *model,Vector *data);

    virtual bool Forward(bool add, Vector *model, Vector *data )=0;// MUST BE IMPLEMENTED
    virtual bool Adjoint(bool add, Vector *model, Vector *data )=0; // MUST BE IMPLEMENTED
    /*virtual bool ForwardAdd(bool add, Vector *model, Vector *data, float b){return false;}
    virtual bool ForwardScaleAdd(bool add, Vector *model, Vector *data, Vector *scale, float b){return false;}*/

    virtual bool DerivForward(bool, Vector *, Vector *){
      std::cout << "DerivForward needs concrete implementation. Parameters: \n";
      std::cout << "bool add, Vector *model, Vector *data \n";
      return false;
    }

   /* virtual bool DerivForwardAdd(bool add, Vector *model, Vector *data, float b){return false;}
    virtual bool DerivForwardScaleAdd(bool add, Vector *model, Vector *data, Vector *scale, float b){return false;}*/

    virtual bool CostFunction(){return false;}

};

 /* class MultiMap: public Map{
  
  private:

  protected:

  public:
    Map *m1, *m2;
    MultiMap() {};
    MultiMap(Map *m1, Map *m2);
    virtual ~MultiMap() {};
    Map *getMap1() {return m1;}
    Map *getMap2() {return m2;} 
    void setDomain1(Space *dom);
    void setDomain2(Space *dom);
    void setRange1(Space *ran);
    void setRange2(Space *ran);
    Space* getDomain1(){return m1->getDomain();}
    Space* getDomain2(){return m2->getDomain();}
    void checkLogic(MultiVector *model, MultiVector *data); // *****need MultiVector*****

    virtual bool Forward(bool add, MultiVector *model, MultiVector *data){return false;}
    // *********ForwardAdd, etc...*****
    
    virtual bool CostFunction(){return false;}
  }
*/

class Operator: public Map{

  private:

  protected:

  public:
    Operator() {}
    Operator(const Operator &): Map() {}
    virtual ~Operator() {}

    virtual bool Adjoint(bool add, Vector *model, Vector *data )=0; // MUST BE IMPLEMENTED FOR ALL OPERATORS
    virtual bool AdjointAdd(bool, Vector *, Vector *, float){   
      std::cout << "AdjointAdd needs concrete implementation. Parameters: \n";
      std::cout << "bool add, Vector *model, Vector *data, float b \n";
      return false;
    }
    virtual bool AdjointScaleAdd(bool, Vector *, Vector *, Vector *, float){
      std::cout << "AdjointScaleAdd needs concrete implementation. Parameters: \n";
      std::cout << "bool add, Vector *model, Vector *data, Vector *scale, float b \n"; 
      return false;
    }

    virtual bool DerivAdjoint(bool, Vector *, Vector *){
      std::cout << "DerivAdjoint needs concrete implementation. Parameters: \n";
      std::cout << "bool add, Vector *model, Vector *data \n"; 
      return false;
    }

    virtual bool DerivAdjointAdd(bool, Vector *, Vector *, float){
      std::cout << "DerivAdjoint needs concrete implementation. Parameters: \n";
      std::cout << "bool add, Vector *model, Vector *data, float b \n";
      return false;
    }

    virtual bool DerivAdjointScaleAdd(bool, Vector *, Vector *, Vector *, float){
      std::cout << "DerivAdjointScaleAdd needs concrete implementation. Parameters: \n";
      std::cout << "bool add, Vector *model, Vector *data, Vector *scale, float b \n"; 
      return false;
    }

    virtual bool DotTest(bool verb);
};



    class MultiOperator: public Operator{
      private:
        char multiType;
      protected:

      public:
        MultiOperator(){};
        MultiOperator(const Operator &, const Operator &, char type){
          multiType = type;
        };
        virtual ~MultiOperator() {};
   
    };

}
#endif
