#include "axis.h"
#include <cstring>
#include <iostream>


using std::string;

SEP::axis::axis(long long n, float o, float d, string label, string unit){
  this->axis_set(n,o,d,label,unit);
}

SEP::axis::axis(long long n, float o, float d, string label){
  string unit="Undefined";
  this->axis_set(n,o,d,label,unit);
}

SEP::axis::axis(long long n, float o, float d){
  string label="Undefined";
  string unit="Undefined";
  this->axis_set(n,o,d,label,unit);
}

SEP::axis::axis(long long n){
  string label="Undefined";
  string unit="Undefined";
  this->axis_set(n,0.,1.,label,unit);
}

void SEP::axis::axis_set(long long n, float o, float d, string label, string unit){
  this->n=n;
  this->o=o;
  this->d=d;
  this->label=label;
  this->unit=unit;
}

bool SEP::axis::axisCheck(axis ax){
  if(this->d < 1e-7) std::cout << "Warning: axis d is too small \n";
}

bool SEP::axis::axisCompatible(axis ax){
  bool match=true;
  if(this->n != ax.n) match=false;
  if(abs(this->d/ax.d-1.) > 0.01) match=false;
  return match;
}

