#include "conv.h"
#include <iostream>
#include <cstdlib>

bool SEP::Conv::Forward(bool add, Vector *model, Vector *data){

  if(!add) data->zeroElement();

  float *__restrict__ m = ((dataInCoreFloat*)model->getDataContainer())->getFloatPtr();
  float *__restrict__ d = ((dataInCoreFloat*)data->getDataContainer())->getFloatPtr();
  float *__restrict__ b = ((dataInCoreFloat*)filter->getDataContainer())->getFloatPtr();
  long long nm=((inCoreFloat*)model->getSpace())->get_n(0);
  long long nd=((inCoreFloat*)data->getSpace())->get_n(0);     
  long long nf = ((inCoreFloat*)filter->getSpace())->get_n(0);
  if ( nd < nm+nf-2) {
     std::cout<<"Data space too small.\n";
  }

  for(long long i=0; i<nf-1; i++){
    for(long long j=0; j<nm-1; j++){ long long k = i+j;
      d[k]+=m[j]*b[i];
    }
  }

  return true;
}


bool SEP::Conv::Adjoint(bool add, Vector *model, Vector *data){

  if(!add) model->zeroElement();

  float *__restrict__ m = ((dataInCoreFloat*)model->getDataContainer())->getFloatPtr();
  float *__restrict__ d = ((dataInCoreFloat*)data->getDataContainer())->getFloatPtr();
  float *__restrict__ b = ((dataInCoreFloat*)filter->getDataContainer())->getFloatPtr();
  long long nm=((inCoreFloat*)model->getSpace())->get_n(0);
  long long nd=((inCoreFloat*)data->getSpace())->get_n(0);
  long long nf = ((inCoreFloat*)filter->getSpace())->get_n(0);
  if ( nd < nm+nf-2) {
     std::cout<<"Data space too small.\n";
  }

  for(long long i=0; i<nf-1; i++){
    for(long long j=0; j<nm-1; j++){ long long k = i+j;
      m[j]+=d[k]*b[i];
    }
  }
  
  return true;  

}
