#ifndef CONVOLUTION_H
#define CONVOLUTION_H 1
#include "Operator.h"
#include "filter.h"
#include "inCoreFloat.h"

namespace SEP {
 class convolution: public Operator{
  public:
   convolution(){};
   convolution(inCoreFloat *mod, inCoreFloat *dat, filter_class *filt){
      //Check to make sure mod and dat same size
      setDomain(mod);
      setRange(dat);
      f=filt;
   } ;
   ~convolution(){};
   virtual bool Forward(bool add, Vector *model, Vector *data );
   virtual bool Adjoint(bool add, Vector *model, Vector *data );
 
   private:
    filter_class *f;
  

 };
}

#endif
