#include "deriv.h"
#include <iostream>
#include <cstdlib>

bool SEP::Deriv::Forward(bool add, Vector *model, Vector *data){

  if(!add) data->zeroElement();

  float *__restrict__ m = ((dataInCoreFloat*)model->getDataContainer())->getFloatPtr();
  float *__restrict__ d = ((dataInCoreFloat*)data->getDataContainer())->getFloatPtr();

  inCoreFloat *sp=(inCoreFloat*)model->getSpace();//get n?
  int n=sp->get_n123();

  for(int i=0; i<n-1; i++){
    d[i]+=m[i+1]-m[i];
  }

  return true;
}


bool SEP::Deriv::Adjoint(bool add, Vector *model, Vector *data){

  if(!add) model->zeroElement();

  float *__restrict__ m = ((dataInCoreFloat*)model->getDataContainer())->getFloatPtr();
  float *__restrict__ d = ((dataInCoreFloat*)data->getDataContainer())->getFloatPtr();

  inCoreFloat *sp=(inCoreFloat*)data->getSpace();//get n?
  int n=sp->get_n123();

  for(int i=0; i<n-1; i++){
    m[i+1]+=d[i];
    m[i]-=d[i];
  }
  
  return true;

}
