#ifndef EXCEPTION_H
#define EXCEPTION_H 1
#include<exception>
#include<string>
#include<ostream>
#define BUFLEN 1024
namespace SEP {




class SEPException: public std::exception {
  private:
    std::string msg;
  public:
    SEPException(): msg("") {}
    
    SEPException(const std::string& s): msg(s) {}

    SEPException(const SEPException &s): std::exception(), msg(""){ 
      msg+=s.msg;
    }
    virtual ~SEPException() throw() {}
    
    
    SEPException & operator<< ( std::string str ) { 
      msg += str;
      return *this;
    }
    const char* what() const throw() { return msg.c_str(); }

    SEPException & operator<< ( const char* str ) { 
      msg += str;
      return *this;
    }
    SEPException & operator<< ( int i ) {
      char buf[ BUFLEN ];
      sprintf( buf, "%d", i );
      msg += buf;
      return *this;
    }
    SEPException & operator<< ( unsigned int i ) {
      char buf[ BUFLEN ];
      sprintf( buf, "%u", i );
      msg += buf;
      return *this;
    }
    SEPException & operator<< ( long i ) {
      char buf[ BUFLEN ];
      sprintf( buf, "%ld", i );
      msg += buf;
      return *this;
    }
    SEPException & operator<< ( unsigned long i ) {
      char buf[ BUFLEN ];
      sprintf( buf, "%lu", i );
      msg += buf;
      return *this;
    }
    SEPException & operator<< ( short i ) {
      char buf[ BUFLEN ];
      sprintf( buf, "%d", i );
      msg += buf;
      return *this;
    }
    SEPException & operator<< ( unsigned short i ) {
      char buf[ BUFLEN ];
      sprintf( buf, "%d", i );
      msg += buf;
      return *this;
    }
    /*
    SEPException & operator<< ( off_t i ) {
      char buf[ BUFLEN ];
      sprintf( buf, "%zd", i );
      msg += buf;
      return *this;
    }
    */
    SEPException & operator<< ( double d ) {
      char buf[ BUFLEN ];
      sprintf( buf, "%g", d );
      msg += buf;
      return *this;
    }
    SEPException & operator<< ( float d ) {
      char buf[ BUFLEN ];
      sprintf( buf, "%g", d );
      msg += buf;
      return *this;
    }
    template<class T>
  /*
  SEPException & operator<< ( complex<T> d ) {
      char buf[ BUFLEN ];
      sprintf( buf, "(%g,%g)", d.real(),d.imag() );
      msg += buf;
      return *this;
    }
*/
    SEPException & operator<< ( char c ) {
      char buf[ BUFLEN ];
      buf[ 0 ] = c;
      buf[ 1 ] = '\0';
      msg += buf;
      return *this;
    }

    std::ostream & write(std::ostream & str) const {
      str<<msg<<std::endl;
      return str;
    }
  };

}
#endif
