#include "filter.h"


//PEF filter

pef_filter::pef_filter(std::vector<long long> ndim){

  for(long long i=0; i <(long long) ndim.size(); i++){
    //Check to make sure that the size of the box is odd
    assert(nsz[i]%(long long) 2==(long long) 1);
  }
  for(long long i=0; i < (long long) ndim.size(); i++) nsz[i]=ndim[i];
  for(long long i=ndim.size(); i < 5; i++) nsz[i]=1;
  coefs=filt_5d(boost::extents[nsz[0]][nsz[1]][nsz[2]][nsz[3]][nsz[4]]);
  for(long long i4=0; i4 < nsz[4]; i4++){
  for(long long i3=0; i3 < nsz[3]; i3++){
  for(long long i2=0; i2 < nsz[2]; i2++){
  for(long long i1=0; i1 < nsz[1]; i1++){
  for(long long i0=0; i0 < nsz[0]; i0++){

    coefs[i0][i1][i2][i3][i4]=0.;

  }}}}}
  
  iAmPEF = true;

  vals=(float*)coefs.data();

}

//Standard filter


standard_filter::standard_filter(std::vector<long long> ndim){

  for(long long i=0; i <(long long) ndim.size(); i++){
    //Check to make sure that the size of the box is odd
    assert(nsz[i]%2==1);
  }
  for(long long i=0; i < (long long)ndim.size(); i++) nsz[i]=ndim[i];
  for(long long i=ndim.size(); i < 5; i++) nsz[i]=1;
  
  coefs=filt_5d(boost::extents[nsz[0]][nsz[1]][nsz[2]][nsz[3]][nsz[4]]);
  for(long long i4=0; i4 < nsz[4]; i4++){
  for(long long i3=0; i3 < nsz[3]; i3++){
  for(long long i2=0; i2 < nsz[2]; i2++){
  for(long long i1=0; i1 < nsz[1]; i1++){
  for(long long i0=0; i0 < nsz[0]; i0++){
    coefs[i0][i1][i2][i3][i4]=0.;
  }}}}}
  vals=(float*) coefs.data();  
  iAmPEF = false;
};
