#ifndef FILTER_H
#define FILTER_H 1
#include <boost/multi_array.hpp> 
#include "dataContainer.h"
#include "DataInCoreFloat.h"


typedef boost::multi_array<float, 5> filt_5d;


class filter_class{

  protected:
    long long nsz[5];
    filt_5d coefs;
    bool iAmPEF;

  public:
  filter_class(){;}
  long long* return_size(){ return nsz;}
  bool return_pef(){return iAmPEF;}
  float* vals;
  ~filter_class(){      
     vals=0;
   }




};
//PEF filter
class pef_filter: public filter_class{


  public:
    pef_filter(std::vector<long long> ndim);
      

  private:

};

//Standard filter

class standard_filter: public filter_class{


  public:
    standard_filter(std::vector<long long> ndim);
      

  private:

};


#endif
