#include "intconv.h"
#include <iostream>
#include <cstdlib>
// Internal convolution
bool SEP::Intconv::Forward(bool add, Vector *model, Vector *data){

  if(!add) data->zeroElement();

  float *__restrict__ m = ((dataInCoreFloat*)model->getDataContainer())->getFloatPtr();
  float *__restrict__ d = ((dataInCoreFloat*)data->getDataContainer())->getFloatPtr();
  float *__restrict__ b = ((dataInCoreFloat*)filter->getDataContainer())->getFloatPtr();
  //long long nm=((inCoreFloat*)model->getSpace())->get_n(0);
  long long nd=((inCoreFloat*)data->getSpace())->get_n(0);     
  long long nf = ((inCoreFloat*)filter->getSpace())->get_n(0);


  for(long long i=0; i<nf-1; i++){
    for(long long j=nf-lag; j<nd-lag; j++){ long long k = j-i+lag-1;
      d[k]+=m[j]*b[i];
    }
  }

  return true;
}


bool SEP::Intconv::Adjoint(bool add, Vector *model, Vector *data){

  if(!add) model->zeroElement();

  float *__restrict__ m = ((dataInCoreFloat*)model->getDataContainer())->getFloatPtr();
  float *__restrict__ d = ((dataInCoreFloat*)data->getDataContainer())->getFloatPtr();
  float *__restrict__ b = ((dataInCoreFloat*)filter->getDataContainer())->getFloatPtr();
//  long long nm=((inCoreFloat*)model->getSpace())->get_n(0);
  long long nd=((inCoreFloat*)data->getSpace())->get_n(0);
  long long nf = ((inCoreFloat*)filter->getSpace())->get_n(0);


  for(long long i=0; i<nf-1; i++){
    for(long long j=nf-lag; j<nd-lag; j++){ long long k = j-i+lag-1;
      m[j]+=d[k]*b[i];
    }
  }
  
  return true;  

}
