#ifndef KIRCHHOFF_H
#define KIRCHHOFF_H 1
#include "Operator.h"
#include "DataInCoreFloat.h"
#include "inCoreFloat.h"
namespace SEP {

class Kirchfast2d: public Operator{

  public:

    Kirchfast2d(Space *mod, Space *data){
      setDomain(mod); 
      setRange(data);
      init();
    }

    ~Kirchfast2d(){ clean(); }

    virtual bool Forward(bool add, Vector *model, Vector *data);
    virtual bool Adjoint(bool add, Vector *model, Vector *data);

    void SetVrms(Vector * _Vrms) {
      delete Vrms; Vrms  = _Vrms;}
    void setAxes(axis d1, axis d2, axis m1, axis m2);
    void SetModelPar(float z0,float dz,float x0,float dx);
    void SetDataPar(float t0,float dt,float y0,float dy);
    void SetAperture(float amin, float amax);

  private:
    void init();
    void clean();
    axis d1,d2,m1,m2;
    float x0, dx, z0, dz, t0, dt, y0, dy;
    long long nx, nz, nt, ny;
    float amin, amax; // aperture in degree
    Vector *Vrms;
};

}

#endif