#include "matmul.h"

bool SEP::Matmul::Forward(bool add, Vector *model, Vector *data){

  if(!add) data->zeroElement();

  float *__restrict__ m = ((dataInCoreFloat*)model->getDataContainer())->getFloatPtr();
  float *__restrict__ d = ((dataInCoreFloat*)data->getDataContainer())->getFloatPtr();
  float *__restrict__ A = ((dataInCoreFloat*)matrix->getDataContainer())->getFloatPtr();

       //array= new float_2d(boost::extents[n1][n2]);

  for (long long i=0; i<n1; i++) {
    for (long long  j=0; j<n2; j++) {
      d[i] += A[i*n2+j]*m[j];
    }
  }
  
  return true;

}


bool SEP::Matmul::Adjoint(bool add, Vector *model, Vector *data){
//std::cout<<"in matmul cpp";
  if(!add) model->zeroElement();

  float *__restrict__ m = ((dataInCoreFloat*)model->getDataContainer())->getFloatPtr();
  float *__restrict__ d = ((dataInCoreFloat*)data->getDataContainer())->getFloatPtr();
  float *__restrict__ A = ((dataInCoreFloat*)matrix->getDataContainer())->getFloatPtr();

  for (long long  i=0; i<n1; i++) {
    for (long long  j=0; j<n2; j++) {
      m[j] += A[i*n2+j]*d[i];
    }
  }
  
  return false;

}
