#ifndef MATMUL_H
#define MATMUL_H 1
#include "Operator.h"
#include "DataInCoreFloat.h"

namespace SEP {

class Matmul: public Operator{

  public:

    Vector *matrix;
    long long n1, n2;

    Matmul(Space *mod, Space *data, Vector *mat){
      setDomain(mod); 
      setRange(data);
      matrix = mat;

      n1 = ((inCoreFloat*)matrix->getSpace())->get_n(0);
      n2 = ((inCoreFloat*)matrix->getSpace())->get_n(1);

      if (n1 != ((inCoreFloat*)data)->get_n123() || n2 != ((inCoreFloat*)mod)->get_n123()) {
        std::cout<<"Dimensions do not agree.\n";
      }

    };

    ~Matmul(){};
    
    virtual bool Forward(bool add, Vector *model, Vector *data);
    virtual bool Adjoint(bool add, Vector *model, Vector *data);

};

}

#endif
