#ifndef SPRAYSUM_H
#define SPRAYSUM_H 1
#include "Operator.h"
#include "DataInCoreFloat.h"
#include "inCoreFloat.h"
namespace SEP {

class Spraysum: public Operator{

  public:

    Spraysum(Space *mod, Space *data){
      setDomain(mod); 
      setRange(data);
      init();
    }

    ~Spraysum(){ clean(); }
 
    virtual bool Forward(bool add, Vector *model, Vector *data);
    virtual bool Adjoint(bool add, Vector *model, Vector *data);
    void OP_info();

  private:
    void init();
    void clean();
    void set_bms(std::vector<long long> temp_dims, int index);
    void Spray(Vector *in_vec, Vector *out_vec, int iop);
    void Sum(Vector *in_vec, Vector *out_vec, int iop);
    void spraysum1d(Vector *in_vec, Vector *out_vec, int iop, bool direction);
    std::vector<inCoreFloat*> inter_space;
    int dimension;
    int op_number;
    std::vector<bool> op_direction;
    std::vector<int> op_dim;
    std::vector<long long> bigs;
    std::vector<long long> middles;
    std::vector<long long> smalls;
    std::vector<long long> blocks;
    std::vector<long long> init_dim;
};

}

#endif