/** SEP Unit Test 1
    Purpose: test Space and Vector constructors.
*/

#include <iostream>
#include <cstdlib>
#include <seplib.h>
#include "../Vector.h"
#include "../inCoreFloat.h"
#include "../DataInCoreFloat.h"
#include <assert.h>
#include<stdbool.h>
#include<string>
//#include "../sep_params.h"
//#include </opt/SEP/SEP6.4.6/include/seplib.h>


using namespace std;
using namespace SEP;

int main(int argc, char **argv){

  try {  
	cout << "TEST 1: Create vector space, vector, assignment of elements to values, assignment of pointer to space, shallow copy constructor, zero-out vector, test compatibility of spaces of the same dimension.\n";
initpar(argc,argv);//doc(" ");
   //sep_params pars=sep_params(argc,argv);

/* Test out creating a vector space, a vector, and assigning its elements to be consecutive integers, check compatibility of spaces */
     int n = 16000005; // sets dimension of space to test
     inCoreFloat1D  *oneD2=new inCoreFloat1D(1500);
     inCoreFloat1D  *oneD=new inCoreFloat1D(n); // create n-D space
     inCoreFloat1D *oneD3=new inCoreFloat1D(n); // create compatible space
    //data1DFloat *x= (data1DFloat*)oneD->buildDataContainer();
   // delete x;
     Vector *vx=new Vector(oneD); // create vector from space and data container
     delete vx; 
     //assert(1==2);
//auxinout("out1");
float *tmp;
tmp=(float*)malloc(n*4);
srite("out1",tmp,sizeof(float)*n);
     //inCoreFloat1D *onep=new inCoreFloat1D(n);
     //oneD.print_it();
     //fprintf(stderr,"before second \n");
     //onep->print_it();
     //fprintf(stderr,"before vector call \n");
     Vector v1(oneD); // create vector from space and data container

     
/******************start of test****/
     dataInCoreFloat *x= ((dataInCoreFloat*)v1.getDataContainer());
     float *array1=x->getFloatPtr();
     double indexDbl = 1.0; // will be used to fill in array with consecutives
     for (int i=0; i<n; i++){
	array1[i] = float(indexDbl);
	indexDbl = indexDbl + double(1.0);
     }
     float *array111=((dataInCoreFloat*)v1.getDataContainer())->getFloatPtr();
     float maxDiff = 0.0; // will take max over vector, see if it's assigned correctly
     int maxDiffIn = 0;
     for (int i=0; i<n; i++) {
	if(i > 16000000) { // need to do the -1 in double once numbers are large enough
		if(float(abs((double(array111[i])-double(i)-1)/(double(i)+
1))) >= maxDiff) {
			maxDiffIn = i;
			maxDiff = float(abs((double(array111[i])-double(i)-1)/(double(i)+1)));
		 }
	}
	else {
		if(abs((array111[i]-float(i+1))/float(i+1)) >= maxDiff) {
			maxDiffIn = i;
			maxDiff = abs((array111[i]-float(i+1))/float(i+1));
		}

	}
     }
     if(maxDiff > 1.0e-6){ // If the sum isn't right, show
	cout << "ERROR: Assignment of vector elements is wrong in test 1.\n";  // the elements of the array.
	cout << "The maximum relative difference was "<< maxDiff << " and\n";
	cout << " it occured in spot " << maxDiffIn << ".\n";
	cout << "What's actually stored there is " << array111[maxDiffIn] << "\n";
	cout << "What should be there is " << maxDiffIn+1 << "\n";
	cout << "The vector should store 1 to " << n << ".\n";
	cout << "It actually stores in the first ten spots:  \n";
	for (int i=0; i<min(n,10); i++) cout << array111[i] << "\n";
     } 


/* Create vector copy of first vector, test the difference of the vectors */  

    Vector v2(&v1); // had to change to use memory address of v1 as input
    float *array2 =   ((dataInCoreFloat*)v2.getDataContainer())->getFloatPtr();

    maxDiff = 0.0; // add up abs value of differences between vectors
    for (int i=0; i<n; i++) {
       maxDiff = max(maxDiff, abs((array2[i] - array1[i])/array1[i]));
       // fprintf(stderr,"CEHCK %d %f %f \n",i,array1[i],array2[i]);
       
       }
    if(maxDiff > 1e-6){ // if the difference was noticeable, output vectors.
	cout << "ERROR: Shallow copy of vector 1 into vector 2 was incorrect in test 1. \n";
	cout << "Vector 1 - Vector 2 (first ten entries) \n";
	for (int i=0; i<min(n,10); i++){
		cout << array1[i] << "  -  " << array2[i] << "\n";
	}

    } 

/* Check whether copied data container points to the correct space */

    bool spaceCheck1 = v1.inSpace(oneD); // check if v1 points to right space
    if (spaceCheck1 == 0){ // If v1 doesn't point to right space
    	cout << "ERROR: The inSpace function on Vector 1 doesn't point to the correct space in test 1! \n";
	cout << "spaceCheck1 is " << spaceCheck1 << "\n";
	cout << "Because of this, it is unknown whether the copy of Vector 1 points to the correct space in test 1. \n";
    } else{ // check if v2 points to right space
    	bool spaceCheck2 = v2.inSpace(oneD);
	if(spaceCheck2 == 0) cout << "Vector copy function isn't assigning copied vector to correct space in test 1. \n";
    }
   
/* Try zeroing out vector 2*/

    v2.zeroElement(); // turn v2 into a zero vector 
    maxDiff = .0; // find max abs value of nonzeroes
    for (int i=0; i<n; i++) maxDiff = max(maxDiff, abs(array2[i]));
    if(maxDiff > 1e-12){
        cout << "ERROR: Turning vector 2 into zeros was incorrect in test 1.\n";
	cout << "Vector 2 (first ten entries) \n";
	for (int i=0; i<min(n,10); i++){
		cout << array2[i] << "\n";
	}
    }

/* test compatibility of spaces of the same dimension */
    if(oneD->isCompatible(oneD2)){ // these shouldn't be compatible
	cout << "ERROR: Incompatible spaces reported to be compatible. \n";
    } 
    if(oneD == oneD3){ // check if different spaces of same dimension are compatible
      cout << "ERROR: Compatible (but unique) spaces share memory address. \n";
    }
    bool shouldBeTrue = oneD->isCompatible(oneD3); // check compatibility, don't change identifier key
    if(oneD->isCompatible(oneD3) == false){
      cout << "ERROR: Compatible spaces reported to be incompatible. \n";
    }
    if(*oneD == *oneD3){ // check if different spaces of same dimension are compatible
      cout << "ERROR: Compatible (but unique) spaces share memory address or key. \n";
    }
    shouldBeTrue = oneD->isCompatible(oneD3, true); // check compatibility, change so both have same identifier key
    if((*oneD == *oneD3) == false){
      cout << "ERROR: space.isCompatible(otherSpace, true) doesn't make \n";
      cout << "identifier keys of space and otherSpace the same. \n";
    } 
    

/* end of test clean up */
     delete oneD;
     delete oneD2;
     delete oneD3;

  }
  catch (SEPException &e) {
    e.write(cout);
    exit(EXIT_FAILURE);
  }
}
