/** SEP Unit Test 8
    Purpose: test dot product on matmul operator
*/

#include <iostream>
#include <cstdlib>
#include "../Vector.h"
#include "../inCoreFloat.h"
#include "../DataInCoreFloat.h"
#include "../matmul.h"
#include <fstream>

using namespace std;
using namespace SEP;

int main() {

  try {  
     cout << "TEST 10: Test matmul operator.\n";

     int n1, n2;
     n1 = 200;
     n2 = 200;

     inCoreFloat2D twoD(n1,n2);
     inCoreFloat1D oneD1(n1);
     inCoreFloat1D oneD2(n2);

     Vector mat(&twoD);
     Vector *x = new Vector(&oneD2);
     Vector *y = new Vector(&oneD1);

     mat.random();
     x->random();

     Matmul Ax(&oneD2, &oneD1, &mat);

     Ax.Forward(false,x,y);

     float *ax=((dataInCoreFloat*)x->getDataContainer())->getFloatPtr();     
     float *ay=((dataInCoreFloat*)y->getDataContainer())->getFloatPtr();  
     float *amat=((dataInCoreFloat*)mat.getDataContainer())->getFloatPtr();  

     ofstream Afile, xfile,yfile;

     Afile.unsetf(std::ios::floatfield);
     Afile.precision(16);
     xfile.unsetf(std::ios::floatfield);
     xfile.precision(16);
     yfile.unsetf(std::ios::floatfield);
     yfile.precision(16);

     Afile.open("a.txt");
     xfile.open("x.txt");
     yfile.open("y.txt");

     for (int i=0; i<n1; i++) {
       for (int j=0; j<n2; j++) {
         Afile << amat[i*n2+j] << "\n";
       }
     }

     for (int i=0; i<n2; i++){
       xfile << ax[i] << "\n";
     }

     for (int i=0; i<n1; i++){
       yfile << ay[i] << "\n";
     }

     Afile.close();
     xfile.close();
     yfile.close();

     delete x;
     delete y;

  }
  catch (SEPException &e) {
    e.write(cout);
    exit(EXIT_FAILURE);
  }
}
