//
//  test11.cpp
//  sep_vector
//
//  Created by Dave Nichols on 5/13/14.
//  Copyright (c) 2014 Dave Nichols. All rights reserved.
//

/** SEP Unit Test 11
 Purpose: test dot product on sparse matmul operator
 */

#include <iostream>
#include <cstdlib>

#include "../Vector.h"
#include "../inCoreFloat.h"
#include "../DataInCoreFloat.h"
#include "sparsemat.h"

using namespace std;
using namespace SEP;

int main() {
  
  try {
    cout << "TEST 11: Dot test on SparseMat operator.\n";
    
    int n1, n2;
    n1 = 100;
    n2 = 200;
    

    inCoreFloat1D oneD1(n1);
    inCoreFloat1D oneD2(n2);
    
    
    SparseMat Ax(&oneD2, &oneD1 );
    
    for( size_t i=0; i< min(n1,n2) ;++i){
      Ax.s_mat(i,i) = i;
    }
    
    
    Ax.DotTest(true);
  }
  catch (SEPException &e) {
    e.write(cout);
    exit(EXIT_FAILURE);
  }
}

