/** SEP Unit Test 7
    Purpose: test dot product on deriv operator, 2nd deriv operator
*/

#include <iostream>
#include <cstdlib>
#include "../Vector.h"
#include "../inCoreFloat.h"
#include "../DataInCoreFloat.h"
#include "../conv.h"


using namespace std;
using namespace SEP;

int main() {

  try {  
     cout << "TEST Conv: Dot test on transient convolution.\n";
     int nm, nd, nf;
     nm = 100;
     nf = 20;
     nd = nm + nf -2;
     // Initialize inCoreFloat1D 
     inCoreFloat1D input(nm), filter(nf), output(nd);
     // Create Vector
     Vector *filt = new Vector(&filter); 
     // Initialize the variable to random values
     filt->random();
     //Call the function for Transient Convolution
     Conv conv(&input, &output, filt);
     conv.DotTest(true);
     delete filt;

  }
  catch (SEPException &e) {
    e.write(cout);
    exit(EXIT_FAILURE);
  }
}
