/** SEP Unit test 15
    Purpose: test dot product on kirchhoff migration
    Created by Yinbin 2014-08-07
    Last modified:
*/

#include <iostream>
#include <cstdlib>
#include "../Vector.h"
#include "../inCoreFloat.h"
#include "../DataInCoreFloat.h"
#include "../kirchhoff.h"
#include <fstream>


using namespace std;
using namespace SEP;

int main() {

  try {
     cout << "========================================"<<endl;
     cout << "                                        "<<endl;
     cout << "========================================"<<endl;
     cout << "TEST 15: Test Kirchhoff operator.\n";

    long long n1, n2;
    long long m1, m2;
    n1 = 300;
    n2 = 150;

    m1 = 300;
    m2 = 150;

    inCoreFloat2D model(n1,n2);
    inCoreFloat2D data(m1,m2);


    Kirchfast2d kirch(&model, &data);
    kirch.DotTest(true);
  }
  catch (SEPException &e) {
    e.write(cout);
    exit(EXIT_FAILURE);
  }

}
