/** SEP Unit test 20
    Purpose: test for Split Bregman
    Created by Yinbin 2014-08-22
    Last modified:
*/

#include <iostream>
#include <cstdlib>
#include "../Vector.h"
#include "../Operator.h"
#include "../TwoOper.h"
#include "../inCoreFloat.h"
#include "../DataInCoreFloat.h"
#include "../matmul.h"
#include "../ADMMAlg.h"
#include <fstream>
#include <cmath>

using namespace std;
using namespace SEP;

int main() {

  try {
     cout << "========================================"<<endl;
     cout << "                                        "<<endl;
     cout << "========================================"<<endl;
     cout << "TEST 20: Test Split Bregman.\n";
     float lambda = 1.e-3, rho = 2.e-1;
     double rnorm,nrnorm;
     long long n = 100, m1 = 80, m2 = 10;
     inCoreFloat1D mspace(n),dspace1(m1),dspace2(m2);
     inCoreFloat2D opspace1(m1,n), opspace2(m2,n);

     //Vector z(&dspace2), u(&data_sp2);
     Vector m0(&mspace); m0.random();
     Vector inversion(&mspace);  inversion.zeroElement();
     Vector d(&dspace1);
     //Vector b(&data_sp);

     Vector Lvec(&opspace1), Avec(&opspace2);
     Lvec.random(); Avec.random();
     Matmul L(&mspace,&dspace1,&Lvec);
     Matmul A(&mspace,&dspace2,&Avec);

     // Construct data.
     L.Forward(false,&m0,&d);

     rnorm = 1.; nrnorm = 2.;
     int niter = 0;
     ADMM_Solver admm(L,A,inversion,d,lambda,rho,niter);
     admm.SetPar(10,1.e-4,1.e-4);
     admm.SetSPPar(2,4);
     admm.run();
  }
  catch (SEPException &e) {
    e.write(cout);
    exit(EXIT_FAILURE);
  }

}