/** SEP Unit Test 7
    Purpose: test dot product on deriv operator, 2nd deriv operator
*/

#include <iostream>
#include <cstdlib>
#include "../Vector.h"
#include "../inCoreFloat.h"
#include "../DataInCoreFloat.h"
#include "../deriv.h"
//#include "../deriv2nd1D.h"

using namespace std;
using namespace SEP;

int main() {

  try {  
     cout << "TEST 7: Dot test on deriv and deriv2nd1D operators.\n";

     int n = 5000000;
     inCoreFloat1D oneD(n); 

     // first order forward derivative in 1D test
     Deriv deriv(&oneD, &oneD);
     deriv.setDomain(&oneD);
     deriv.setRange(&oneD);
     deriv.DotTest(true);

  /*   // second derivative in 1D test
     Deriv2nd1D deriv2(&oneD, &oneD);
     deriv2.setDomain(&oneD);
     deriv2.setRange(&oneD);
     deriv2.DotTest(true); // ****the true doesn't do anything (verb in DotTest)
  */
  }
  catch (SEPException &e) {
    e.write(cout);
    exit(EXIT_FAILURE);
  }
}
