/** SEP Unit Test 8
    Purpose: test dot product on matmul operator
*/

#include <iostream>
#include <cstdlib>
#include "../Vector.h"
#include "../inCoreFloat.h"
#include "../DataInCoreFloat.h"
#include "../matmul.h"

using namespace std;
using namespace SEP;

int main() {

  try {  
     cout << "TEST 8: Dot test on matmul operator.\n";

     int n1, n2;
     n1 = 1000;
     n2 = 1000;

     inCoreFloat2D twoD(n1,n2);
     inCoreFloat1D oneD1(n1);
     inCoreFloat1D oneD2(n2);

     Vector mat(&twoD);

     mat.random();

     Matmul Ax(&oneD2, &oneD1, &mat);

     Ax.DotTest(true);
  }
  catch (SEPException &e) {
    e.write(cout);
    exit(EXIT_FAILURE);
  }
}
