#include "Nmo.h"

bool SEP::Nmo::Forward(bool add, Vector *model, Vector *data){

  if(!add) data->zeroElement();

  float s=0,x=0,tau=0,wt=0,t=0;
  int it=0;

  float *__restrict__ m = ((dataInCoreFloat*)model->getDataContainer())->getFloatPtr();
  float *__restrict__ d = ((dataInCoreFloat*)data->getDataContainer())->getFloatPtr();

  for(is=0;is<ns;is++){
    s=os+(is-1)*ds
    for(ix=0;ix<nx;ix++){
      x=ox+(ix-1)*dx
      for(itau=0;itau<ntau;itau++){
      tau=otau+(itau-1)*dtau

      t=sqrt(s*s*x*x+z*z)
      wt=(t-ot)/dt
      it=wt
      wt=wt-it
      it=it+1
      if(it>=1. && it+1<=nt){
        d[it+nt*ix]+=   (1.-wt)*m[itau+ntau*is]
        d[it+1+nt*ix]+=      wt*m[itau+ntau*is]
      }
      }
    }
  }

}


bool SEP::Nmo::Adjoint(bool add, Vector *model, Vector *data){


  if(!add) model->zeroElement();

  float s=0,x=0,tau=0,wt=0,t=0;
  int it=0;

  float *__restrict__ m = ((dataInCoreFloat*)model->getDataContainer())->getFloatPtr();
  float *__restrict__ d = ((dataInCoreFloat*)data->getDataContainer())->getFloatPtr();

  for(is=0;is<ns;is++){
    s=os+(is-1)*ds
    for(ix=0;ix<nx;ix++){
      x=ox+(ix-1)*dx
      for(itau=0;itau<ntau;itau++){
      tau=otau+(itau-1)*dtau

      t=sqrt(s*s*x*x+z*z)
      wt=(t-ot)/dt
      it=wt
      wt=wt-it
      it=it+1
      if(it>=1. && it+1<=nt){
	m[itau+ntau*is]+=(1.-wt)*d[it+nt*ix]+wt*d[it+1+nt*ix];
      }
      }
    }
  }

}
