#ifndef NMO_H
#define NMO_H 1
#include "Operator.h"

namespace SEP {

class Nmo: public Operator{

  private:

    int   ntau,ns,nt,nx;
    float otau,dtau,os,ds,ot,dt,ox,dx;

  public:

    Nmo(Vector *mod, Vector *data,float o_tau,float d_tau,float o_s,float d_s,float o_t,float d_t,float o_x,float d_x){
      setDomain((inCoreFloat*)mod->getSpace()); 
      setRange((inCoreFloat*)data->getSpace());

      ntau = ((inCoreFloat*)mod->getSpace())->get_n(0);
      ns = ((inCoreFloat*)mod->getSpace())->get_n(1);

      nt = ((inCoreFloat*)data->getSpace())->get_n(0);
      nx = ((inCoreFloat*)data->getSpace())->get_n(1);

      otau=o_tau;dtau=d_tau;os=o_s;ds=d_s,ot=o_t,dt=d_t,ox=o_x,dx=d_x;

      /*if (n1 != ((inCoreFloat*)data)->get_n123() || n2 != ((inCoreFloat*)mod)->get_n123()) {
        std::cout<<"Dimensions do not agree.\n";
      }*/

    };

    ~Nmo(){};
    
    virtual bool Forward(bool add, Vector *model, Vector *data);
    virtual bool Adjoint(bool add, Vector *model, Vector *data);

};

}

#endif
