#include "deriv2nd1D.h"

bool SEP::Deriv2nd1D::Forward(bool add, Vector *model, Vector *data){
  if(!add) data->zeroElement();

  float *__restrict__ m = ((dataInCoreFloat*)model->getDataContainer())->getFloatPtr();
  float *__restrict__ d = ((dataInCoreFloat*)data->getDataContainer())->getFloatPtr();

  inCoreFloat *sp=(inCoreFloat*)model->getSpace();
  int n=sp->get_n123();

  d[0]+=m[0];
  d[1]+=m[1]-2*m[0];
  for(int i=2; i<n-1; ++i){ // got to get indexing right
    d[i]+=m[i]-2*m[i-1]+m[i-2]; 
  }

}

bool SEP::Deriv2nd1D::Adjoint(bool add, Vector *model, Vector *data){
  if(!add) model->zeroElement();

  float *__restrict__ m = ((dataInCoreFloat*)model->getDataContainer())->getFloatPtr();
  float *__restrict__ d = ((dataInCoreFloat*)data->getDataContainer())->getFloatPtr();

  inCoreFloat *sp=(inCoreFloat*)data->getSpace();
  int n=sp->get_n123();

  m[0]+=d[0]-2*d[1]; // note: +d[2] done in forloop
  m[1]+=d[1]; // note -2*d[2]+d[3] done in forloop
  for(int i=2; i<n-1; ++i){
    m[i-2]+=d[i];
    m[i-1]-=2*d[i];
    m[i]+=d[i];
  }
}
