#include <iostream>
#include <cstdlib>

//I think we can just link to the sepvector library however..
#include "../base/Vector.h"
#include "../base/inCoreFloat.h"
#include "../base/DataInCoreFloat.h"
#include "../base/matmul.h"
#include "../base/CGStep.h"
#include "Nmo.h"

using namespace std;
using namespace SEP;

int main() {

  try {

    int ntau,ns,nt,nx;
    int niter;
    float otau,dtau,os,ds,ot,dt,ox,dx;
    bool adj;
    double res=1000;

    //do from param calls here, cheat for now
    ntau=101;otau=0.;dtau=0.04;
    ns=101;  os=0.2; ds=0.004;
    nt=101;  ot=0.;  dt=0.04;
    nx=101;  ox=-5.0;dx=0.1;
    niter=20;

    //inCoreFloat2D mod_sp = new inCoreFloat2D(ntau,ns);
    //inCoreFloat2D dat_sp = new inCoreFloat2D(nt,  nx);
    inCoreFloat2D mod_sp(ntau,ns);
    inCoreFloat2D dat_sp(nt,  nx);

    Vector mod(&mod_sp),dat(&dat_sp);
    Vector g(&mod_sp),rr(&dat_sp),gg(&dat_sp);

    mod.zeroElement(); dat.zeroElement();

    Nmo op(&mod,&dat,otau,dtau,os,ds,ot,dt,ox,dx);

    //read the data

    dat.addInv(rr);

    CGStep cg;
    cg.Alloc_step(mod, rr);

    Vector s(&mod_sp), ss(&dat_sp);
    s.zeroElement(); 
    ss.zeroElement();

    bool forget = 1;

    for(int iter=0;iter<niter;iter++){
      fprintf(stderr,"Iteration %d \n",iter);
      op.Adjoint(true,&g,&rr);
      op.Forward(false,&g,&gg);
      cg.Step(iter, mod, g, rr, gg, res);
      fprintf(stderr,"Residual %g \n",res);
    }

    //write out model

  }
  catch (SEPException &e) {
    e.write(cout);
    exit(EXIT_FAILURE);
  }
}

