#include "lint1.h"
#include <iostream>
#include <cstdlib>

// Linear interpolation assuming uniform spacing like (1/2n,3/2n,5/2n,...) going 
// from that to (1/2m,3/2m, 5/2m,...) for another spacing

bool SEP:Lint1::Forward(bool add, Vector *model, Vector *data){
  if(!add) data->ZeroElement();

  float *__restrict__ m = ((dataInCoreFloat*)model->getDataContainer())->getFloatPtr();
  float *__restrict__ d = ((dataInCoreFloat*)data->getDataContainer())->getFloatPtr();

  inCoreFloat *sp=(inCoreFloat*)model->getSpace();
  int n=sp->get_n123();
  inCoreFloat *sp2=(inCoreFloat*)data->getSpace();
  int nd=sp->get_n123;
  
  for(int id=0; id<nd-1; id++){
    float f = (float(id)/float(2*nd) - float(1.)/float(2*n))*float(n);
    int i = f;
    int im = i+1;
    if(0<=im && im<n-1){ // typical case
      float fx = f-float(id);
      float gx = 1.0-fx;
      d[id]+= gx*m[im] + fx*m[im+1];
    } else if(im == -1){  // before first model point
      d[id] += m[im+1];
    } else{ // im == n-1, above last model point
      d[id] += m[im];
    }
  }

}

bool SEP::Lint1::Adjoint(bool add, Vector *model, Vector *data){
  if(!add) data->ZeroElement();

  float *__restrict__ m = ((dataInCoreFloat*)model->getDataContainer())->getFloatPtr();
  float *__restrict__ d = ((dataInCoreFloat*)data->getDataContainer())->getFloat_Ptr();

  inCoreFloat *sp=(inCoreFloat*)model->getSpace();
  int n=sp->get_n123();
  inCoreFloat *sp2=(inCoreFloat*)data->getSpace();
  int nd=sp->get_n123;

  for(int id=0; id<nd-1; it++){
    float f = (float(id)/float(2*nd) - float(1.)/float(2*n))*float(n);
    int i = f;
    int im = i+1;
    if(0<=im && im<n-1){ // typical case, or 
      float fx = f-float(id);
      float gx = 1.0-fx;
      m[im] += gx*d[id];
      m[im+1] += fx*d[id];
    } else if(im == -1){ // before first model poitn
      m[0] += d[id];
    } else{ // im == n-1, above last model point
      m[im] += d[id];
    }
  }
}
