//
//  sparsemat.cpp
//  sep_vector
//
//  Created by Dave Nichols on 5/13/14.
//  Copyright (c) 2014 Dave Nichols. All rights reserved.
//

#include "sparsemat.h"

bool SEP::SparseMat::Forward(bool add, Vector *model, Vector *data){
  
  if(!add) data->zeroElement();
  
  float *__restrict__ m = ((dataInCoreFloat*)model->getDataContainer())->getFloatPtr();
  float *__restrict__ d = ((dataInCoreFloat*)data->getDataContainer())->getFloatPtr();
  

  long long n1 = s_mat.size1(); // nrow
  long long n2 = s_mat.size2();  // ncol
  
  for (long long i=0; i<n1; i++) {
    for (long long  j=0; j<n2; j++) {
      d[i] += s_mat(i,j)*m[j];
    }
  }
  
  // replace with ? need shallow array adaptor?
  // bool zeroit = !add;

  //boost::numeric::ublas::axpy_prod(s_mat, m, d, zeroit );  // w = A * u
  
  return true;
  
}


bool SEP::SparseMat::Adjoint(bool add, Vector *model, Vector *data){
  //std::cout<<"in matmul cpp";
  if(!add) model->zeroElement();
  
  float *__restrict__ m = ((dataInCoreFloat*)model->getDataContainer())->getFloatPtr();
  float *__restrict__ d = ((dataInCoreFloat*)data->getDataContainer())->getFloatPtr();
  
  long long n1 = s_mat.size1(); // nrow
  long long n2 = s_mat.size2();  // ncol
  
  
  for (long long  i=0; i<n1; i++) {
    for (long long  j=0; j<n2; j++) {
      m[j] += s_mat(i,j)*d[i];
    }
  }
  
  
  // replace with ?
  // bool zeroit = !add;
  //boost::numeric::ublas::c_vector<float,n1> d_vec( n1, m  );
  // boost::numeric::ublas::axpy_prod(m, s_mat, d, zeroit );  // w = A * u
  
  return false;
  
}
