//
//  sparsemat.h
//  sep_vector
//
//  Created by Dave Nichols on 5/13/14.
//  Copyright (c) 2014 Dave Nichols. All rights reserved.
//

#ifndef __sep_vector__sparsemat__
#define __sep_vector__sparsemat__

#include "Operator.h"
#include <boost/numeric/ublas/matrix_sparse.hpp>
#include <boost/numeric/ublas/io.hpp>

namespace SEP {
  
  class SparseMat: public Operator{
    
  public:
    
    boost::numeric::ublas::compressed_matrix<float> s_mat;
  
 
     public:
    
    SparseMat(Space *mod, Space *data): s_mat( ((inCoreFloat*)data)->get_n123() , ((inCoreFloat*)mod)->get_n123() ){
      setDomain(mod);
      setRange(data);
      
    };
    
    ~SparseMat(){};
    
    virtual bool Forward(bool add, Vector *model, Vector *data);
    virtual bool Adjoint(bool add, Vector *model, Vector *data);
    
  };
  
}
#endif /* defined(__sep_vector__sparsemat__) */
